#ifndef __OctreeCHCOcclusionCameraDepthTraversal_H
#define __OctreeCHCOcclusionCameraDepthTraversal_H

#include "OctreeCHCPrerequisites.h"
#include "OctreeCHCCamera.h"

namespace OgreOctreeCHC
{
    //-----------------------------------------------------------------------
    // 
    class RegisterCameraDepthTraversal : public DepthTraversalConst
    {
	    private:
		    const OctreeCHCCamera * const cam;

	    public:
		    RegisterCameraDepthTraversal(OctreeCHCCamera *c) : cam (c) {};
		    void onDepthTree(SpatialTree& n) const ;
		    void onDepthLeaf (SpatialTreeNode& n) const ;
	};
    //-----------------------------------------------------------------------
    // 
    class UnregisterCameraDepthTraversal : public DepthTraversalConst
    {
	    private:
		    const OctreeCHCCamera * const cam;

	    public:
            UnregisterCameraDepthTraversal(OctreeCHCCamera *c) : cam (c) {};
		    void onDepthTree(SpatialTree& n) const ;
		    void onDepthLeaf (SpatialTreeNode& n) const ;
	};

	//-----------------------------------------------------------------------
	// 
	class ResetCameraVisibilityInfo : public DepthTraversalConst
	{
	private:
		const OctreeCHCCamera * const cam;

	public:
		ResetCameraVisibilityInfo(OctreeCHCCamera *c) : cam (c) {};
		void onDepthTree(SpatialTree& n) const ;
		void onDepthLeaf (SpatialTreeNode& n) const ;
	};
}
#endif //OctreeCHCOcclusionCameraDepthTraversal
