
#include "OctreeCHCPrecompiledHeaders.h"

#include "OctreeCHCPrerequisites.h"

#include "OctreeCHCCamera.h"
#include "OctreeCHC.h"
#include "OctreeCHCNode.h"
#include "OctreeCHCOcclusionElement.h"
#include "OctreeCHCOcclusion.h"

#include "OctreeCHCOcclusionVisibilityData.h"
#include "OctreeCHCOcclusionTraversal.h"
#include "OctreeCHCOcclusionDebugTraversal.h"


#include "OgreRectangle2D.h"


using namespace Ogre;


namespace OgreOctreeCHC
{
    // Debug Info 
    //-----------------------------------------------------------------------
    TreeOverlayDebug::TreeOverlayDebug(OcclusionCulling& o):
            mOcclusion(o)
    {
    }
    //-----------------------------------------------------------------------
    void TreeOverlayDebug::onDepthTree(SpatialTree& n) const 
	{    
		if (!n.hasRectangle2d())
			n.setDebugCorners();

		SimpleRenderable * const s = n.getRectangle2d();
        if (n.viewFrustumVisible)
        {
		    if (n.queriedVisible || !mOcclusion.getOcclusionModeIsHWOcclusion()) 
			{
				s->setMaterial ("GreenOverlayInfo");
                mOcclusion.mCurrentRenderQueue->addRenderable (s, s->getRenderQueueGroup());
                depthTraverseChildren (n);
		    }
		    else 
            {
                s->setMaterial ("RedOverlayInfo");
                mOcclusion.mCurrentRenderQueue->addRenderable (s, s->getRenderQueueGroup());
		    }
	    }
	    else 
		{
            s->setMaterial ("BlueOverlayInfo");
            mOcclusion.mCurrentRenderQueue->addRenderable (s, s->getRenderQueueGroup());
	    }       
    }
    //-----------------------------------------------------------------------
    void TreeOverlayDebug::onDepthLeaf (SpatialTreeNode& n) const 
	{
		if (n.isStaticNode())
		{
			if (!n.hasRectangle2d())
				n.setDebugCorners();
		}
		else
		{
			n.setDebugCorners();
		}

		SimpleRenderable * const s = n.getRectangle2d();
	    if (n.viewFrustumVisible)
        {
		    if (n.queriedVisible || !mOcclusion.getOcclusionModeIsHWOcclusion()) 
            {
                s->setMaterial ("WhiteOverlayInfo");
                mOcclusion.mCurrentRenderQueue->addRenderable(s, s->getRenderQueueGroup());          
		    }
		    else 
            {
                s->setMaterial ("RedOverlayInfo");
                mOcclusion.mCurrentRenderQueue->addRenderable(s, s->getRenderQueueGroup());
		    }
	    }
        else 
        { 
            s->setMaterial ("BlueOverlayInfo");
            mOcclusion.mCurrentRenderQueue->addRenderable(s, s->getRenderQueueGroup());
	    }
    }
}
   